<script>
    import Spinner from 'components/Icons/Spinner.svelte'
    import { awaitingAPI } from 'store'
    import { createEventDispatcher } from 'svelte'

    export let hasMore = true

    const dispatch = createEventDispatcher()

    const observe = element => {
        const observer = new IntersectionObserver((entries, observer) => {
            if (!hasMore) {
                observer.unobserve(element)
            }

            entries.forEach(entry => {
                if (entry.isIntersecting && !$awaitingAPI && hasMore) {
                    dispatch('more')
                }
            })
        })

        observer.observe(element)

        return {
            destroy: () => {
                observer.disconnect()
            },
        }
    }
</script>

<div use:observe>
    {#if $awaitingAPI}<Spinner />{:else}Plus de messages à afficher{/if}
</div>

<style lang="postcss">
    div {
        @apply flex justify-center p-2 text-blueGray-500;
    }
</style>
